#include <LiquidCrystal_I2C.h>
#include <Wire.h>

#include <Servo.h>

LiquidCrystal_I2C lcd(0x3f, 16, 2);

const int trigPin = 9;
const int echoPin = 10;
const int servoPin = 6;
const int buttonPin = 2;

int input[] = {echoPin, buttonPin};
int output[] = {trigPin};

long duration;
int distance;

Servo servo1;

#define THRESHOLD 10

void setup() {
  lcd.init();
  lcd.backlight();

  lcd.begin(0, 0);

  lcd.print("Welcome!");

  servo1.attach(6);

  for(int i = 0; i < sizeof(input); i++) {
    pinMode(input[i], INPUT);
  }
  for(int i = 0; i < sizeof(output); i++) {
    pinMode(output[i], OUTPUT);
  }

  Serial.begin(9600);
}

void open() {
  lcd.begin(0, 0);
  lcd.print("Status: Open");

  servo1.write(60);
}

void close() {
  lcd.begin(0, 0);
  lcd.print("Status: Close");
  servo1.write(0);
}

void loop() {
  digitalWrite(trigPin, HIGH);
  duration = pulseIn(echoPin, HIGH);
  distance = duration * 0.034 / 2;
  Serial.print("Distance: ");
  Serial.println(distance);
  Serial.println(digitalRead(2));
  if(digitalRead(2) == HIGH) {
    open();
  } else {
    if(distance < THRESHOLD) {
      open();
    } else {
      close();
    }
  }


  digitalWrite(trigPin, LOW);
}
